diff --git a/src/backend/replication/walsender.c b/src/backend/replication/walsender.c
index d46374d..ed756be 100644
--- a/src/backend/replication/walsender.c
+++ b/src/backend/replication/walsender.c
@@ -279,6 +279,14 @@ InitWalSender(void)
 
 	/* Initialize empty timestamp buffer for lag tracking. */
 	memset(&LagTracker, 0, sizeof(LagTracker));
+
+	/*
+	 * Initialize walsenders xmin for hot_standby_feedback corner case when
+	 * autovacuum GetOldestXmin and truncates tuples that replica needs, but has not
+	 * yet informed the master because starts transaction at same time with autovacuum.
+	 * If hot_standby_feedback is off walsender will send at least one feedback message.
+	 */
+	MyPgXact->xmin = GetOldestXmin(NULL, PROCARRAY_FLAGS_DEFAULT);
 }
 
 /*
